## spherepack 3.2

=== Src/Makefile ===
libsphere.a:    *.f
	g77 -c *.f
	ld -r -o libsphere.a *.o

=== debian/changelog ===
spherepack (3.2-9build2) artful; urgency=medium

  * No-change rebuild to build to drop python3.5.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 05 Aug 2017 16:28:17 +0000

spherepack (3.2-9build1) artful; urgency=medium

  * Rebuild for python 3.6 support.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sat, 13 May 2017 19:36:37 +0530

spherepack (3.2-9) unstable; urgency=medium

  * Move to Standards-Version: 3.9.8. No changes required.
  * Ensure *.f, *.o are compiled in LC_ALL=C order for bit-reproducibility

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Mar 2016 14:18:45 +0000

spherepack (3.2-8) unstable; urgency=medium

  * Add '--default-double-8' to avoid performance issue with libquadmath:
    see http://glennklockwood.blogspot.ie/2014/02/linux-perf-libquadmath-and-gfortrans.html

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Dec 2015 10:00:13 +0000

spherepack (3.2-7) unstable; urgency=medium

  * Fix rules so that shared lib always built first, not python wrappers.
    Closes: #734824.
  * Move to Standards-Version: 3.9.5 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Jan 2014 09:42:06 +0000

spherepack (3.2-6) unstable; urgency=low

  * Fortran ABI change: Now build with --default-real-8; 
  * Add python3-sphere  package.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 Jul 2013 07:34:38 +0100

spherepack (3.2-5) unstable; urgency=low

  * Transtion from python-support to dh_python2. 
  * Standards-Version: 3.9.4. No changes required.
  * Fortify the shared library.

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 19 May 2013 06:54:01 +0100

spherepack (3.2-4) unstable; urgency=low

  * --with=python-support needs to be explicity stated when moving
    to debhelper COMPAT=9. Closes: #662680.
  * Move to Standards-Version: 3.9.3. No changes required.
  * Add C/F77 interface support. Closes: #611812. 

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 12 Mar 2012 09:31:25 +0000

spherepack (3.2-3) unstable; urgency=low

  * B-D on python-support. Closes: #642474
  * Add --as-needed to lib build line.
  * Multi-Arch enabled.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 24 Sep 2011 11:25:59 +0100

spherepack (3.2-2) unstable; urgency=low

  * Call dh_numpy to add versioned dependency on numpy. Closes: #641766
  * Standards-Version: 3.9.2

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 16 Sep 2011 11:18:19 +0100

spherepack (3.2-1) unstable; urgency=low

  * Initial release. (Closes: #602285)

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Nov 2010 12:38:37 +0000

=== debian/control ===
Source: spherepack
Section:  utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), python-all-dev (>= 2.6.2~) , gfortran, 
 python-numpy, python3-numpy, python3-all-dev,
 python-setuptools, python3-setuptools
Standards-Version: 3.9.8
X-Python-Version: >= 2.6
X-Python3-Version: >= 3.2
Homepage:  http://www.cisl.ucar.edu/css/software/spherepack/

Package: libsphere-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libsphere0d (= ${binary:Version})
Description: Development files for Spherepack scientific library
 SPHEREPACK is a collection of FORTRAN programs that facilitates computer 
 modeling of geophysical processes. The package contains programs for computing
 certain common differential operators including divergence, vorticity, 
 gradients, and the Laplacian of both scalar and vector functions. Programs are
 also available for inverting these operators. For example, given divergence
 and vorticity, the package can be used to compute the velocity components. 
 The Laplacian can also be inverted and therefore the package can be used 
 to solve both the scalar and vector Poisson equations. Its use in model 
 development is demonstrated by a sample program that solves the time-dependent
 non-linear shallow-water equations. Accurate solutions are obtained via the 
 spectral method that uses both scalar and vector spherical harmonic transforms
 that are available to the user. The package also contains utility programs 
 for computing the associated Legendre functions, Gauss points and weights, 
 and multiple fast Fourier transforms. Programs are provided for both 
 equally-spaced and Gauss distributed latitudinal points as well as programs 
 that transfer data between these grids.

Package: libsphere0d
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Spherepack scientific library for geophysical processes
 SPHEREPACK is a collection of FORTRAN programs that facilitates computer 
 modeling of geophysical processes. The package contains programs for computing
 certain common differential operators including divergence, vorticity, 
 gradients, and the Laplacian of both scalar and vector functions. 
 .
 This package contains the shared library, libsphere.
 
Package: python-sphere
Section: python
Architecture: any
Multi-Arch: foreign
Depends: ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}, libsphere0d (=${binary:Version}), python-numpy
Provides: ${python:Provides}
Description: Python interface to the spherepack scientific library.
 This is a python interface to spherepack, a library for geophysical processes.

Package: python3-sphere
Section: python
Architecture: any
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}, libsphere0d (=${binary:Version}), python3-numpy
Description: Python3 interface to the spherepack scientific library.
 This is a python3 interface to spherepack, a library for geophysical processes.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# magic debhelper rule
%:
	dh  $@  --with python2,python3

PYTHON2=$(shell pyversions -vr)
PYTHON3=$(shell py3versions -vr)


DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build:
	cp debian/aliases.ld Src/aliases.ld
	$(MAKE) -C Src all
	dh_auto_build
	# For some reason, dh_strip isn't stripping this properly, according to lintian
	strip Src/libsphere.a

override_dh_auto_install: $(PYTHON3:%=install-python%)
	$(MAKE) -C Src install DESTDIR=`pwd`/debian/tmp PREFIX=/usr LIBDIR=$(LIBDIR)
	dh_auto_install
	dh_link -p libsphere-dev $(LIBDIR)/libsphere.so.0d $(LIBDIR)/libsphere.so
	dh_numpy
	dh_numpy3

override_dh_auto_clean:
	dh_clean
	$(MAKE) -C Src clean || echo "No clean target in original Makefile"
	rm -rf build Src/aliases.ld

build-python%:
	python$* setup.py build

install-python%:
	python$* setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb

## spherepack 3.3~a1

=== Src/Makefile ===
libsphere.a:    *.f90
	gfortran -c *.f90
	ld -r -o libsphere.a *.o

clean:
	rm -f *.o

%.o: %.f90
	$(FC) $(FFLAGS) -c $<

=== debian/changelog ===
spherepack (3.3~a1-8build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 15:06:03 +0000

spherepack (3.3~a1-8build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 19:42:02 +0000

spherepack (3.3~a1-8) unstable; urgency=medium

  * Update numpy path in patch for numpy2 transition

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 27 Jan 2025 13:32:49 +0000

spherepack (3.3~a1-7) unstable; urgency=medium

  * Build against fortranobject.o to resolve missing symbols
  * Fix reference to 'import spherepack' as layout has changed.
    Closes: #1093051
  * Delete patches removed:
    - python-link.patch 
    - make.patch 
    - reproduciblity.patch 
    - setuptools.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Jan 2025 13:02:45 +0000

spherepack (3.3~a1-6) unstable; urgency=medium

  * Update build system to meson, enable python3.13 builds
    Closes: #1076926
  * Delete patches merged into meson build:
    - pkgconfig.patch
    - fortify.patch
    - 8byte.patch
  * Build-depend on python3-mesonpy
  * Drop B-D on python3-skbuild, setuptools
  * Update homepage
  * Drop obsolete Pre-Depends in d/control
  * Use fortran-support.mk, build for default Fortran only
  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Jan 2025 18:50:37 +0000

spherepack (3.3~a1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062919

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:14:54 +0000

spherepack (3.3~a1-5) unstable; urgency=medium

  * Standards-Version: 4.6.1
  * Fix  install paths for python3*

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 23 Aug 2021 12:01:41 +0100

spherepack (3.3~a1-4) unstable; urgency=medium

  * Set autopkgtests as superficial. Closes: #970971
  * Set default branches to /latest, in VCS-Git and d/gbp.conf
  * Move to debhelper-compat 13

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Oct 2020 10:58:48 +0100

spherepack (3.3~a1-3) unstable; urgency=medium

  * Fix FTBFS with gfortran-10. Closes: #957833

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 18 Apr 2020 12:41:17 +0100

spherepack (3.3~a1-2) unstable; urgency=medium

  * Drop flang support temporarily for llvm transition
  * Ensure it builds when flang is not present 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 31 Mar 2020 19:07:09 +0100

spherepack (3.3~a1-1) unstable; urgency=medium
 
  * Upstream release with double-precision variants
  * Support flang and gfortran builds
  * Standards-Version: 4.5.0
  * Use dh-sequence-python3 rather than --with python3
  * Add basic python3 load test

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Mar 2020 11:56:12 +0000

spherepack (3.2-13) unstable; urgency=medium

  * Move to debhelper-compat 12
  * Standards-Version: 4.4.0
  * Drop python-sphere for python2 transition. Closes: #938527
  * Use pybuild build system for debhelper 12
  * Set LD_LIBRARY_PATH during build

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Sep 2019 16:28:00 +0100

spherepack (3.2-12) unstable; urgency=medium

  * Standards-Version: 4.3.0
  * Drop Obsolete X-Python* in d/control
  * B-D on gfortran | fortran-compiler
  * Change build references gfortran -> f95
  * Change --default-real-8 etc to -fdefault-real-8 for flang compatibility

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Feb 2019 10:09:06 +0000

spherepack (3.2-11) unstable; urgency=medium

  * Add C interface for spherepack, thanks to Christophe Trophime.
    Closes: #895265
  * Standards-Version: 4.1.4
  * Build against python3.7

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 01 Jul 2018 17:48:10 +0100

spherepack (3.2-10) unstable; urgency=medium

  * Standards-Version: 4.1.3
  * Update homepage to https: version
  * Now use debhelper 10
  * B-D on dh-python
  * Set VCS to salsa.debian.org
  * Temp. disable setuptools patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Mar 2018 12:43:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,24 @@
 Source: spherepack
 Section:  utils
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 9), python-all-dev (>= 2.6.2~) , gfortran, 
- python-numpy, python3-numpy, python3-all-dev,
- python-setuptools, python3-setuptools
-Standards-Version: 3.9.8
-X-Python-Version: >= 2.6
-X-Python3-Version: >= 3.2
-Homepage:  http://www.cisl.ucar.edu/css/software/spherepack/
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
+Build-Depends: debhelper-compat (= 13),  
+ dh-sequence-python3,
+ dh-fortran-mod (>= 0.31),
+ python3-numpy, 
+ python3-all-dev,
+ python3-mesonpy (>= 0.15.0~)
+Standards-Version: 4.7.0
+Homepage: https://www.cisl.ucar.edu/research-software/software
+Vcs-Browser: https://salsa.debian.org/science-team/spherepack.git
+Vcs-Git: https://salsa.debian.org/science-team/spherepack.git -b debian/latest
 
 Package: libsphere-dev
 Section: libdevel
 Multi-Arch: same
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libsphere0d (= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libsphere0t64 (= ${binary:Version})
 Description: Development files for Spherepack scientific library
  SPHEREPACK is a collection of FORTRAN programs that facilitates computer 
  modeling of geophysical processes. The package contains programs for computing
@@ -33,10 +37,13 @@
  equally-spaced and Gauss distributed latitudinal points as well as programs 
  that transfer data between these grids.
 
-Package: libsphere0d
+Package: libsphere0t64
+Provides: ${t64:Provides}
+X-Time64-Compat: libsphere0d
+Replaces: libsphere0d
+Breaks: libsphere0d (<< ${source:Version})
 Section: libs
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Spherepack scientific library for geophysical processes
@@ -47,20 +54,11 @@
  .
  This package contains the shared library, libsphere.
  
-Package: python-sphere
-Section: python
-Architecture: any
-Multi-Arch: foreign
-Depends: ${python:Depends}, ${misc:Depends}, ${shlibs:Depends}, libsphere0d (=${binary:Version}), python-numpy
-Provides: ${python:Provides}
-Description: Python interface to the spherepack scientific library.
- This is a python interface to spherepack, a library for geophysical processes.
-
 Package: python3-sphere
 Section: python
 Architecture: any
 Multi-Arch: foreign
-Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}, libsphere0d (=${binary:Version}), python3-numpy
+Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}, libsphere0t64 (=${binary:Version}), python3-numpy
 Description: Python3 interface to the spherepack scientific library.
  This is a python3 interface to spherepack, a library for geophysical processes.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/debhelper/dh-fortran/fortran-support.mk

# magic debhelper rule
%:
	dh  $@  --buildsystem=pybuild

PYTHON3:=$(shell py3versions -vr)
PY3DEFAULT:=$(shell py3versions -vd)

FC:=$(shell basename $(shell readlink /etc/alternatives/f95))
F77:=$(shell basename $(shell readlink /etc/alternatives/f77))
export F77 FC

FLANG_COMPILER:=flang-new-17

DO_FLANG:=$(if $(wildcard /usr/bin/$(FLANG_COMPILER)),true, false)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DESTDIR:=$(CURDIR)/debian/tmp
LIBDIR:=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
LIBDIR_FC:=$(LIBDIR)/fortran/$(FC_DEFAULT)

LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp:$(LD_LIBRARY_PATH)
export LD_LIBRARY_PATH

override_dh_auto_configure: $(PYTHON3:%=configure-python%)
	:

override_dh_auto_build: $(PYTHON3:%=build-python%)
	:
	# meson compile -C build-$(PY3DEFAULT) sphere:static_library sphere:shared_library

override_dh_auto_install: $(PYTHON3:%=install-python%)
	mkdir -p $(LIBDIR_FC) 
	mv $(DESTDIR)/usr/lib/python3/dist-packages/Src $(DESTDIR)/usr/lib/python3/dist-packages/sphere
	cp Lib/__init__.py Lib/sphere.py $(DESTDIR)/usr/lib/python3/dist-packages/sphere
	mv $(LIBDIR)/libsphere.a $(LIBDIR_FC)
	cp build-$(PY3DEFAULT)/Src/libsphere.so $(LIBDIR)/libsphere-$(FC_DEFAULT).so.0d
	ln -s libsphere-$(FC_DEFAULT).so.0d $(LIBDIR)/libsphere-$(FC_DEFAULT).so
	ln -s ../../libsphere-$(FC_DEFAULT).so.0d $(LIBDIR_FC)/libsphere.so
	dh_numpy3

override_dh_auto_test: $(PYTHON3:%=test-python%)
	:

override_dh_auto_clean:
	rm -rf build-* .pybuild

configure-python%:
	python$* /usr/bin/meson setup --prefix /usr --buildtype plain build-$* 

build-python%:
	python$* /usr/bin/meson compile -C build-$*

test-python%:
	python$* /usr/bin/meson test -C build-$*

install-python%:
	python$* /usr/bin/meson install -C build-$* --destdir $(DESTDIR)
